rem Make data file for Palm Pilot tide table database builder

del harmonic.inp
del offsets.inp
copy harmonics.txt[1]+harmonics_dubious.txt harmonic.inp
copy offsets.xml[1]+offsets_depend_on_dubious.xml offsets.inp

tide -fyear 1998 -nyears 34 -dumpfactors -hfile harmonic.inp
del TideArgs.pdb
rename tideargs TideArgs.pdb

tide -fyear 1998 -nyears 17 -dumpfactors -hfile harmonic.inp
del SmallArgs.pdb
rename tideargs SmallArgs.pdb

del foo
del listfile.txt

tide -cf t -dID 1 -dNM "U.S. West Coast" -dtide "cisco, C" -dcur "Golden" -ltf 31.9 -ltt 49.3 -lnf -116 -lnt -125  -x "British" >> foo
call renamedb

tide -cf t -dID 2 -dNM "Maine to Massachusetts" -dtide "Bost" -dcur "Bost" -ltf 46 -ltt 40.5 -lnf -66.9 -lnt -71.83 -x "New B">> foo
call renamedb

tide -cf t -dID 3 -dNM "Newport RI to Cape May NJ" -dtide "New Y" -dcur "The N" -ltf 38 -ltt 46 -lnf -71.83 -lnt -74.96 >> foo
call renamedb

tide -cf t -dID 4 -dNM "Cape May NJ to Virginia" -dtide McHenry -dcur Baltim -ltf 40 -ltt 36.55 -lnf -74.96 -lnt -82 >> foo
call renamedb

tide -cf t -dID 5 -dNM "North Carolina to Georgia" -dtide Charleston -dcur Charles -ltf 36.55 -ltt 30.7 -lnf -75 -lnt -82 >> foo
call renamedb

tide -cf t -dID 6 -dNM "Florida East" -dtide "Key West" -dcur "Key West" -ltf 24 -ltt 30.7 -lnf -79.5 -lnt -82.10 >> foo
call renamedb

tide -cf t -dID 7 -dNM "Gulf Coast & Florida West" -dtide Pleasure -dcur Galveston -ltf 25.94 -ltt 35 -lnf -82.10 -lnt -97.75 >> foo
call renamedb

tide -cf t -dID 8 -dNM "Alaska" -dtide "Skag" -dcur Wrang -ltf 50 -ltt 90 -lnf -120 -lnt 170  -x British -x Nunavut>> foo
call renamedb

tide -cf t -dID 10 -dNM "Canada (Southeast), N Atl" -dtide Halifax -dcur Manan -ltf 43.1 -ltt 47 -lnf -11 -lnt -120 -x "Maine" >> foo
call renamedb

tide -cf t -dID 11 -dNM "Canada (Central East), N Atl" -dtide "St. John's" -ltf 47 -ltt 53 -lnf -11 -lnt -120 -x "Maine" >> foo
call renamedb

tide -cf t -dID 12 -dNM "Canada (Northeast), N Atl" -dtide "Iqaluit" -ltf 53 -ltt 90 -lnf -11 -lnt -120 >> foo
call renamedb

tide -cf t -dID 13 -dNM "Canada (Southwest)" -dtide "Vancou" -dcur "First" -ltf 48 -ltt 49.5 -lnf -120 -lnt -179 -x "Wash" >> foo
call renamedb

tide -cf t -dID 14 -dNM "Canada (Central West)" -dtide "Seym" -dcur "Seym" -ltf 49.5 -ltt 51 -lnf -120 -lnt -179 -x "Alaska" >> foo
call renamedb

tide -cf t -dID 15 -dNM "Canada (Northwest)" -dtide "Queen" -dcur "Nak" -ltf 51 -ltt 90 -lnf -120 -lnt -179 -x "Alaska" >> foo
call renamedb

tide -cf tcarib -dID 20 -dNM "Carribean" -dtide "San J" -dcur "Vieques" -ltf 32.5 -ltt 0 -lnf -118 -lnt -45 >> foo
call renamedb

tide -cf t -dID 21 -dNM "Mexico" -dtide "Tampico" -i Mexico -ltf 15 -ltt 25 -lnf -93 -lnt -130 >> foo
call renamedb

tide -cf t -dID 22 -dNM "South America" -dtide "Janeiro" -ltf -90 -ltt 0 -lnf -100 -lnt -33 >> foo
call renamedb

: UK and British Isles data removed on request of U.K.H.O.
:tide -cf t -dID 30 -dNM "Great Britain" -dtide "London" -ltf 49.83 -ltt 59.5 -lnf 1.84 -lnt -11 -x France >> foo
:call renamedb

tide -cf t -dID 31 -dNM "Northern Europe" -dtide "Cherb" -ltf 46.5 -ltt 90 -lnf -5 -lnt 180 -x Engl -x Scotl -x Wale -x Alask >> foo
call renamedb

tide -cf t -dID 32 -dNM "Mediterranean" -dtide "Casab" -ltf 46.5 -ltt 31 -lnf -40 -lnt 40 >> foo
call renamedb

tide -cf t -dID 33 -dNM "Africa, Asia Minor" -dtide "Cape Town" -ltf -90 -ltt 31 -lnf -25 -lnt 60 >> foo
call renamedb

tide -cf t -dID 41 -dNM "Pacific Islands" -dtide "Honolu" -ltf 22 -ltt -60 -lnf -100 -lnt 131 -x Mexico -x Austr >> foo
call renamedb

tide -cf t -dID 42 -dNM "Australia" -dtide "Sydney" -ltf -0 -ltt -0 -lnf 0 -lnt 0 -i Australia >> foo
call renamedb

tide -cf t -dID 43 -dNM "Asia" -dtide "Hong" -ltf -60 -ltt 46.5  -lnf 60 -lnt 131 -x Japan -x Austral >> foo
call renamedb

tide -cf t -dID 44 -dNM "Japan (Southwest)" -dtide "Hiagari" -xn Japan -ltf 24 -ltt 45.55 -lnf 122 -lnt 134 >> foo
call renamedb

tide -cf t -dID 45 -dNM "Japan (Northeast)" -dtide "Tokyo" -xn Japan -ltf 24 -ltt 45.55 -lnf 134 -lnt 150 >> foo
call renamedb


