/*  A Bison parser, made from xml.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse xmlparse
#define yylex xmllex
#define yyerror xmlerror
#define yylval xmllval
#define yychar xmlchar
#define yydebug xmldebug
#define yynerrs xmlnerrs
#define	NAME	258
#define	ATTVALUE	259
#define	XMLSTART	260

#include "xml.h"
#include "tidelib.h"
#define max(a,b)    (((a) > (b)) ? (a) : (b))
#define min(a,b)    (((a) < (b)) ? (a) : (b))

typedef enum {TREETOP, NO_ATTRIB, SUBSTA, SIMPLE_OFF, HAIRY_OFF,
			LEVELADD, LEVELMULTIPLY, TIMEADD, MAX, 
			MIN, FLOODBEGINS, EBBBEGINS, AVGLEVEL, DIRECTION } attype;
struct xmltag *xmlparsetree;
static void walktree(struct xmltag *, attype, int );
extern int lineno;
extern int xmllex ();

#define balance(lname,rname) {                            \
      if ((*(lname)) != (*(rname))) {                     \
        printf("\nERROR: <%s> ended by <%s>\n",(*(lname)),(*(rname)));        \
        xmlerror("In balance");                         \
      }                                                   \
      delete rname; }

void freexml (struct xmltag *v) {
  if (!v)
    return;
  freexml (v->next);
  freexml (v->contents);
  freexml (v->attributes);
  delete v->name;
  delete v;
}

void freexml (struct xmlattribute *v) {
  if (!v)
    return;
  freexml (v->next);
  delete v->value;
  delete v->name;
  delete v;
}

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		39
#define	YYFLAG		-32768
#define	YYNTBASE	10

#define YYTRANSLATE(x) ((unsigned)(x) <= 260 ? yytranslate[x] : 15)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     8,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     6,
     9,     7,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     3,     5,     8,    17,    27,    33,    41,    50,    55,
    57,    60
};

static const short yyrhs[] = {     5,
    11,     0,    12,     0,    11,    12,     0,     6,     3,    13,
     7,     6,     8,     3,     7,     0,     6,     3,    13,     7,
    11,     6,     8,     3,     7,     0,     6,     3,    13,     8,
     7,     0,     6,     3,     7,     6,     8,     3,     7,     0,
     6,     3,     7,    11,     6,     8,     3,     7,     0,     6,
     3,     8,     7,     0,    14,     0,    13,    14,     0,     3,
     9,     4,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
    65,    78,    80,    85,    94,   103,   111,   120,   129,   139,
   141,   146
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","NAME","ATTVALUE",
"XMLSTART","'<'","'>'","'/'","'='","xml_file","taglist","tag","avlist","attribute", NULL
};
#endif

static const short yyr1[] = {     0,
    10,    11,    11,    12,    12,    12,    12,    12,    12,    13,
    13,    14
};

static const short yyr2[] = {     0,
     2,     1,     2,     8,     9,     5,     7,     8,     4,     1,
     2,     3
};

static const short yydefact[] = {     0,
     0,     0,     1,     2,     0,     3,     0,     0,     0,     0,
    10,     0,     0,     0,     9,     0,     0,    11,    12,     0,
     0,     0,     0,     6,     0,     0,     0,     0,     7,     0,
     0,     0,     8,     4,     0,     5,     0,     0,     0
};

static const short yydefgoto[] = {    37,
     3,     4,    10,    11
};

static const short yypact[] = {    -2,
     9,     1,     9,-32768,    -1,-32768,    15,    12,    16,     5,
-32768,    21,     2,    20,-32768,    22,    23,-32768,-32768,    24,
    11,    13,    25,-32768,    26,    29,    31,    14,-32768,    28,
    30,    33,-32768,-32768,    32,-32768,    38,    40,-32768
};

static const short yypgoto[] = {-32768,
    -7,    -3,-32768,    19
};


#define	YYLAST		40


static const short yytable[] = {     6,
    14,     7,     1,     5,     5,     8,     9,     7,    23,    20,
     6,    16,    17,     5,     2,     5,     5,    13,    26,     6,
    27,    32,    15,    12,    19,    21,    25,    22,    18,    24,
    28,    30,    29,    31,    33,    35,    34,    38,    36,    39
};

static const short yycheck[] = {     3,
     8,     3,     5,     3,     3,     7,     8,     3,    16,     8,
    14,     7,     8,     3,     6,     3,     3,     6,     8,    23,
     8,     8,     7,     9,     4,     6,     3,     6,    10,     7,
     6,     3,     7,     3,     7,     3,     7,     0,     7,     0
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

unsigned long memused = 0;
void *    alloca     (size_t __size) {
memused += __size;
   return malloc(__size); }

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug = 0;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif


#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    printf( "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
printf("stack overflow\n"); 
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	printf( "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    printf( "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	printf( "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	printf( "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    printf( "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
{ // Un-reverse the top-level list
      struct xmltag *temp;
      yyval.tag = NULL;
      while (yyvsp[0].tag) {
        temp = yyvsp[0].tag->next;
        yyvsp[0].tag->next = yyval.tag;
        yyval.tag = yyvsp[0].tag;
        yyvsp[0].tag = temp;
      }
      xmlparsetree = yyval.tag; ;
    break;}
case 2:
{ yyval.tag = yyvsp[0].tag;
    break;}
case 3:
{ yyval.tag = yyvsp[0].tag;
      yyval.tag->next = yyvsp[-1].tag; ;
	if (yyval.tag->next && !strcmp(yyval.tag->next->name->aschar(),"subordinatestation")) {
		/* Walt's hack to use the data immediately and free it up. */
		walktree(yyval.tag->next,TREETOP,0);
		freexml(yyval.tag->next);
		yyval.tag->next = NULL;
		}
    break;}
case 4:
{
      balance (yyvsp[-6].value, yyvsp[-1].value);
      if (!(yyval.tag = new xmltag)) xmlerror("Out of memory!\n");
      yyval.tag->name = yyvsp[-6].value;
      yyval.tag->attributes = yyvsp[-5].attribute;
      yyval.tag->contents = NULL;
      yyval.tag->next = NULL;
    break;}
case 5:
{
      balance (yyvsp[-7].value, yyvsp[-1].value);
      if (!(yyval.tag = new xmltag)) xmlerror("Out of memory!\n");
      yyval.tag->name = yyvsp[-7].value;
      yyval.tag->attributes = yyvsp[-6].attribute;
      yyval.tag->contents = yyvsp[-4].tag;
      yyval.tag->next = NULL;
    break;}
case 6:
{
      if (!(yyval.tag = new xmltag)) xmlerror("Out of memory!\n");
      yyval.tag->name = yyvsp[-3].value;
      yyval.tag->attributes = yyvsp[-2].attribute;
      yyval.tag->contents = NULL;
      yyval.tag->next = NULL;
    break;}
case 7:
{
      balance (yyvsp[-5].value, yyvsp[-1].value);
      if (!(yyval.tag = new xmltag)) xmlerror("Out of memory!\n");
      yyval.tag->name = yyvsp[-5].value;
      yyval.tag->attributes = NULL;
      yyval.tag->contents = NULL;
      yyval.tag->next = NULL;
    break;}
case 8:
{
      balance (yyvsp[-6].value, yyvsp[-1].value);
      if (!(yyval.tag = new xmltag)) xmlerror("Out of memory!\n");
      yyval.tag->name = yyvsp[-6].value;
      yyval.tag->attributes = NULL;
      yyval.tag->contents = yyvsp[-4].tag;
      yyval.tag->next = NULL;
    break;}
case 9:
{
      if (!(yyval.tag = new xmltag)) xmlerror("Out of memory!\n");
      yyval.tag->name = yyvsp[-2].value;
      yyval.tag->attributes = NULL;
      yyval.tag->contents = NULL;
      yyval.tag->next = NULL;
    break;}
case 10:
{ yyval.attribute = yyvsp[0].attribute; ;
    break;}
case 11:
{ yyval.attribute = yyvsp[0].attribute;
      yyval.attribute->next = yyvsp[-1].attribute; ;
    break;}
case 12:
{ 	
      if (!(yyval.attribute = new xmlattribute)) xmlerror("Out of memory!\n");
      yyval.attribute->name = yyvsp[-2].value;
      yyval.attribute->value = yyvsp[0].value;
      yyval.attribute->next = NULL; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */


  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else {
	    yyerror ("parse error; also virtual memory exceeded"); }
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	printf( "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    printf( "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}

/* Stuff for unit conversion */
#define NUMUNITS 9
enum Units {
	feet, meters, knots, bogoknots,
	inches, mph, kph, msec, fsec, Default };

static enum Units hUnits[] = { feet, meters, inches, Default};	/* If changed, also change default in tidedb.c */
static enum Units vUnits[] = { knots, mph, kph, msec, fsec, Default};

struct xmltag *myxmlparsetree;
extern FILE *xmlin;
Dstr xmlfilename;
static int PRINTIT = 0;				/* Debugging - to print the parsed tree */
static char *refsta;
static char *tznamstr;
static char *locname;
static char locstr[linelen] = {0};
static char floodflag, ebbflag;
static int firstoffset;
static char getdata;				/* 0 to scan for reference stations, 1 to get data */

struct placeoff node;

/*** Code to walk the parsed tree and stuff the data somewhere useful ***/

static void init_node(void) {			/* Initialize data for node */
	refsta = tznamstr = locname = NULL;
	places[nplaces].units = NUMUNITS;
	places[nplaces].iscurrent = 0;
	latit = longit = MISSINGLAT;
	memset(&node,0,sizeof(node));
	node.mulfactors[0] = node.mulfactors[1] = 100;			/* 1 scaled by 100 */
	floodflag = ebbflag = 0;
	}

/* Eat attribute pair that could be value or units */
#define UNITSVAL 9999.9
static float floatval(char *name, char *val) {
	int i;
	if (!strcmp("value", name)) return atof(val) + 0.005;		/* value */
	if (strcmp("units", name)) {						/* other */
		printf( "Bad attribute: <%s = %s> (expecting \"value\" or \"units\")\n",
			name, val);
		xmlerror("Error in XML input");
		}
	   else {									/* units */
		i = GetUnits(val);
		if (places[nplaces].units != NUMUNITS && i != places[nplaces].units)
			xmlerror("Station has two different kinds of units");
		places[nplaces].units = i;
		if (places[nplaces].units < NUMUNITS) return UNITSVAL;
		printf( "Bad units: <%s>\n", val);
		}
	xmlerror("Error in XML input"); return 0;
	}

static int timeval(char *cc) {
	int val = 0; char *c = cc;
	if (*c == '+' || *c == '-') ++c;
	while (*c) {
	  if (isdigit(*c)) val = 10 * val + *c - '0';
		else if (*c == ':' && isdigit(c[1])) { ++c; val = 6 * val + *c - '0'; }
		else { printf("Bad time value: <%s>\n",cc); xmlerror("Bad time value"); }
	  ++c;
	  }
	if (*cc == '-') return -val;
	return val;
	}

static void walkattribs(struct xmlattribute *att, attype treetype, attype nextype, int pct) {
	char *name;
	char *val;
	char *b, badatt = 0;
	float f;
	int i;

	while (att) {
		name = att->name->aschar();
		val = att->value->aschar();
		if (!*val) {
			xmlerror("Blank or missing value");
			exit(1);
			}
		while ((b = strstr(val,"&quot;")) != 0) {			/* Put quotes back */
			*b++ = '"';
			strcpy(b, b+5);
			}
		while ((b = strstr(val,"&apos;")) != 0) {			/* Put quotes back */
			*b++ = '"';
			strcpy(b, b+5);
			}
      	if (PRINTIT) {
			for (i = pct; i--; ) printf("     ");
			printf("%s = <%s>\n",name,val);
			}
		switch (nextype) {
		   case SUBSTA:
			if (!strcmp(name,"reference")) { refsta = val; }
			else if (!strcmp(name,"timezone")) { tznamstr = val; }
			else if (!strcmp(name,"name")) { locname = val; }
			else if (!strcmp(name,"longitude")) { longit = atof(val); }
			else if (!strcmp(name,"latitude")) { latit = atof(val); }
			else if (!strcmp(name,"pedigree") || !strcmp(name,"comment"));
			else badatt = 1;
			break;
		  case LEVELADD: f = floatval(name, val);
			if (f == UNITSVAL) break;
			switch (treetype) {
				case MAX: node.addfactors[0] = 100.0 * f; break;
				case SIMPLE_OFF: node.addfactors[0] = 100.0 * f; 
				case MIN: node.addfactors[1] = 100.0 * f; break;
				default: badatt = 1;
				}
			break;
		  case LEVELMULTIPLY: f = floatval(name, val);
			if (f == UNITSVAL) break;
			switch (treetype) {
				case MAX: node.mulfactors[0] = 100.0 * f; break;
				case SIMPLE_OFF: node.mulfactors[0] = 100.0 * f; 
				case MIN: node.mulfactors[1] = 100.0 * f; break;
				default: badatt = 1;
				}
			break;
		  case TIMEADD: i = timeval(val);
			switch (treetype) {
				case MAX: node.offsets[0] = i; break;
				case SIMPLE_OFF: node.offsets[0] = i; 
				case MIN: node.offsets[1] = i; break;
				default: badatt = 1;
				}
			break;
		  case FLOODBEGINS: 
			i = timeval(val);
			node.offsets[2] = i; 
			floodflag = 1; break;
		  case EBBBEGINS: 
			i = timeval(val);
			node.offsets[3] = i; 
			ebbflag = 1; break;
		  case AVGLEVEL: 
		  case DIRECTION: break;		/* Ignore these */
			}
		if (badatt) { 
			printf("Bad attribute <%s> at location %s: \n",name,locname);
			xmlerror("Error in tree walk");
			}
		att = att->next;
	}	}	

/* Approximate the square of the distance (in nm) between two points */
/* Assumes E-W distance is what it would be halfway between the latitudes */
/* This gives REALLY bad results if either place is very far north - but hey, real far is real far. */
static float SqDistance(int i, int j) {
	float dx, dy, avglat;
//printf("SqDistance(%d,%d): %lg %lg %lg %lg:",i,j,places[i].latitude,places[j].latitude,places[i].longitude,places[j].longitude);
	dy = 60 * (places[i].latitude - places[j].latitude);		/* In nautical miles */
	dx = 60 * (places[i].longitude - places[j].longitude);	/* In nm only at the equator */
	avglat = (places[i].latitude + places[j].latitude) / 2;	/* Fudge factor */
	dx *= cos(avglat * 3.14159/180.0);
//printf(" dx=%g, dy=%g\n",dx,dy);
	return dx * dx + dy * dy;
	}

/*
**	Walk a tree.  
**	Assumes (as is observed empirically) that there's only one station per tree.
*/
static void walktree(struct xmltag *tree, attype treetype, int pct) {
  int count = 0, i;
  attype nextype;
  char *errstr = NULL;
  char *name;
  int nrefsta, tzindex;
  float absmin, absmax;

  while (tree) {
	if (PRINTIT) {
		if (!pct) printf("%d: ",++count);
	        else for (i = pct; i--; ) printf("     ");
		printf("%s\n",tree->name->aschar());
		}
	name = tree->name->aschar();
	switch (treetype) {		/* Handle tree depending on level */
	   case TREETOP:				/* Top level has to be subordinatestation */
		if (strcmp("subordinatestation",name)) goto error;
		nextype = SUBSTA;
		init_node();
		break;
	   case SUBSTA:				/* Second level must be offsets or simpleoffsets */
		if (!strcmp("simpleoffsets",name)) nextype = SIMPLE_OFF;
		  else if (!strcmp("offsets",name)) nextype = HAIRY_OFF;
		  else goto error;
		break;
	   case MIN: case MAX:
		if (!strcmp("direction",name)) { nextype = DIRECTION; break; }
		   else if (!strcmp("avglevel",name)) { nextype = AVGLEVEL; break; }
		/* FALL THROUGH: can also have any value of a simple offset */
	   case SIMPLE_OFF:			/* Third level: simple offsets */
		if (!strcmp("leveladd",name)) nextype = LEVELADD;
		   else if (!strcmp("levelmultiply",name)) nextype = LEVELMULTIPLY;
		   else if (!strcmp("timeadd",name)) nextype = TIMEADD;
		   else goto error;
		break;
	   case HAIRY_OFF:			/* Fourth level: hairy offsets */
		if (!strcmp("min",name)) nextype = MIN;
		   else if (!strcmp("max",name)) nextype = MAX;
			/* For next two, they have their own attributes, not in a subtree */
		   else if (!strcmp("floodbegins",name)) nextype = FLOODBEGINS;
		   else if (!strcmp("ebbbegins",name)) nextype = EBBBEGINS;
		   else goto error;
		break;
	   default:  error:
		printf("XML data error ");
		if (locname) printf("at <%s> ",locname);
		printf("tag <%s> treetype %d\n",name, treetype);
		xmlerror("Unknown or misplaced tag");
		exit(1);
	}

	/* Get the attributes */
	if (tree->attributes) {
        	if (getdata && PRINTIT) {
			for (i = pct; i--; ) printf("     ");
			printf("--- Attributes:\n");
			}
		walkattribs(tree->attributes, treetype, nextype, pct+1);
		if (getdata && nextype == SUBSTA) {
			/* Check that the important elements are present */
			if (!locname) xmlerror("Location name missing.");
			if (!refsta) errstr = "reference station";
			if (latit == MISSINGLAT) errstr = "latitude";
			if (longit == MISSINGLAT) errstr = "longitude";
			if (errstr) {
				printf("At location %s, no %s specified.\n",locname,errstr);
				xmlerror("Error in secondary station file.");
				}
			strcpy(locstr,locname);
			places[nplaces].iscurrent = CheckCurrent(locstr);
		}	}
	if (tree->contents) {
        	if (getdata && PRINTIT) {
			for (i = pct; i--; ) printf("     ");
			printf("--- Contents:\n");
			}
		walktree(tree->contents, nextype, pct+1);
		}
	if (getdata && PRINTIT) printf("\n");
	tree = tree->next; 
	}
   if (treetype == SUBSTA) {
	/* All data should be present.  Check and write the node if it qualifies. */
	if (!ScreenLocation(locname)) return;			/* Insure the location is in the region */
	if (!getdata) {							/* If pass 1, */
		IsRefStation(refsta, 1);				/*  just add the refsta to the list. */
		return;
		}
#if 0
printf("Location %s (%s)\n",locname, places[nplaces].iscurrent ? "current" : "tide");
printf("\tLatitude %lg longitude %lg\n", latit, longit);
printf("\tTime zone %s, units %d = %s\n", tznamstr, places[nplaces].units, known_units[places[nplaces].units].name);
printf("\tTime offsets %d %d %d %d\n", node.offsets[0],node.offsets[1],node.offsets[2],node.offsets[3]);
printf("\tMul factors %d %d\n",node.mulfactors[0],node.mulfactors[1]);
printf("\tAdd factors %d %d\n",node.addfactors[0],node.addfactors[1]);
#endif
	while ((i = filterit(filters, locstr, 0)) > 0);		/* Reject station on name? */
	if (i == -1) { 
//printf("<%s> rejected - filterit\n",locstr);
		return; }
	/* See if reference station was excluded from the database */
	/* This has no effect except to suppress the error message */
	for (i = 0; i < nexclude; ++i)
		if (strstr(refsta, exclude[i]) != NULL)
			return;
	/* See if reference station is in this database */
	for (nrefsta = 0; nrefsta < nplaces; ++nrefsta) {
		if (!sslackcmp(placeinfo[nrefsta].origlocation,refsta)) goto gotit;
		}
	if (InTheSquare(latit, longit)) {
//printf("Place 1 %s cmp = %d\n",placeinfo[1].origlocation,sslackcmp(placeinfo[1].origlocation,refsta)) ;
		printf("ERROR: <%s> is in the selected region, but\n",locname);
		printf("\tref station <%s> was not found.\n",refsta); 
		fprintf(stderr,"Reference station <%s> was not found.\n",refsta); 
		xmlerror("Reference Station Missing");
		}
	return;
	gotit:
	RoundLatLon();
	places[nplaces].latitude = latit;
	places[nplaces].longitude = longit;
	node.primary = nrefsta;
   	for (i = 0; i < nplaces-1; ++i) 			/* Check for duplication */
	    if (places[i].iscurrent == places[nplaces].iscurrent) {
		if (SqDistance(i,nplaces) < 0.25) {
#if 0 /******* DEBUGGING **********/
			if (!strcmp(locstr,places[i].location)) {
				printf("REJECTED: Offset duplicates %s: <%s> in %s\n",
					i < firstoffset ? "station" : "offset", locstr,xmlfilename);
//if (i < firstoffset) return;
//printf("At %d, %s duplicates %d: %s\n", nplaces, locstr, i, places[i].location);
//exit(1);
				return; }
#endif
			if (!strcmp(locstr,placeinfo[i].origlocation)) 			/* Sometimes this works better */
				return;
			printf("WARNING - POSSIBLE DUPLICATE location: %s%s \n\tand %s (%s) are %g nm apart\n",
				placeinfo[i].origlocation, i < firstoffset ? "" : " (offset)",locname, xmlfilename.aschar(), sqrt(SqDistance(i,nplaces)));
			}
		if (!strcmp(locstr,places[i].location)) {
			printf("ERROR: <%s> appears at two locations %g nm apart - rejected\n",locname,sqrt(SqDistance(i,nplaces)));
			return;
		}	}
//printf("%d: %s\n",nplaces,locstr);
	/* Compute time zone index */
	if (!tznamstr) tzindex = places[nrefsta].tzindex;
	 else {
	  tzindex = change_time_zone(tznamstr);
        if (!strncmp(Zones[tzindex].longname,"GMT",3)) /* Convert GMT offsets to a neg number */
		tzindex = Zones[tzindex].meridian / 30L - 27;
#if 0
	  if (tzindex != places[nrefsta].tzindex)
		printf("WARNING: %s has time zone %d - \n\tReference Station %s has zone %d\n",
			locstr,tzindex,places[nrefsta].location,places[nrefsta].tzindex);
#endif
	  }
	places[nplaces].tzindex = tzindex;
	if (places[nplaces].units == NUMUNITS) places[nplaces].units = places[nrefsta].units;
	if (places[nplaces].units != places[nrefsta].units && (node.addfactors[0] || node.addfactors[1])) {
		/* Got to convert the units */
#if 0
		printf("WARNING: %s has units %s - \n\tReference Station %s has units %s\n",
			locstr,known_units[places[nplaces].units].name,
			places[nrefsta].location,known_units[places[nrefsta].units].name);
#endif
		if (places[nrefsta].units == bogoknots) {
			printf("ERROR: Can't convert offset to bogoknots yet\n");
			fprintf(stderr,"*** ERROR: Can't convert offset to bogoknots yet. ***\n");
			}
		  else for (i = 0; i <= 1; ++i) {
		 	node.addfactors[i] *= 
				known_units[places[nplaces].units].conv_factor / 
						known_units[places[nrefsta].units].conv_factor;
		}	}
	places[nplaces].units = places[nrefsta].units;			/*** ADOPT THE UNITS OF THE REF STATION ***/ 
	places[nplaces].location = dupstr(locstr);
	placeinfo[nplaces].origlocation = dupstr(locname);
	if (SqDistance(nrefsta,nplaces) > 40000.0)			/* Threshold = 200 mi */
		  printf("Warning: Offset %s is about %g nm from its\n\tReference Station %s\n",
			locname,sqrt(SqDistance(nrefsta,nplaces)),placeinfo[nrefsta].origlocation);
	places[nplaces].meridian = places[nrefsta].meridian;
	places[nplaces].datum = places[nrefsta].datum;
	places[nplaces].issilent = 0;
	/* Compute maximum and minimum amplitudes */
	absmax = placeinfo[nrefsta].absmax * node.mulfactors[0] + node.addfactors[0];
	placeinfo[nplaces].absmax = absmax / 100.0;
	absmin = placeinfo[nrefsta].absmin * node.mulfactors[1] + node.addfactors[1];
	placeinfo[nplaces].absmin = absmin / 100.0;
//printf("Tides from %lg to %lg at %s\n",placeinfo[nplaces].absmin , placeinfo[nplaces].absmax , places[nplaces].location);

#if 0		/* Now done in program to reduce database size */
	/* Compute maximum and minimum time offsets */
	node.minoff = 30000; node.maxoff = -30000;
	for (i = places[nplaces].iscurrent ? 3 : 1; i >=0; --i) {
		if (node.offsets[i] < node.minoff) node.minoff = node.offsets[i];
		if (node.offsets[i] > node.maxoff) node.maxoff = node.offsets[i];
		}
#endif
	if (places[nplaces].iscurrent) {
  // Flater sez: This seems evil, but without it, people will get really unexpected
  // results if they omit slack offsets from current stations.
		if (!floodflag) node.offsets[2] = (node.offsets[0] + node.offsets[1]) / 2;
		if (!ebbflag) node.offsets[3] = (node.offsets[0] + node.offsets[1]) / 2;
		}
	WriteLocationRecord(nplaces, &node);
	if (++nplaces >= MAXPLACES){				/* Don't abort yet - we may just be generating a list */
		if (!too_many_places) {
			fprintf(stderr,"***** FATAL ERROR:  MORE THAN %d PLACES*****\n",MAXPLACES);
			printf("***** FATAL ERROR:  MORE THAN %d PLACES*****\n",MAXPLACES);
			}
		too_many_places = 1;
		--nplaces;
		}
	}
 }

/* Called twice - once to get the reference location list, then after the main
 *	data file is read, called again to read and write the offset data blocks.
 */
void ParseOffsetsFile(int flag) {
      int i;
	getdata = flag;
      firstoffset = nplaces;
	for (i = 0; i < nofffiles; ++i) {
		xmlfilename = offfiles[i];
	      if (!(xmlin = fopen(offfiles[i],"r"))) { 
			printf("Can't open input file %s\n",offfiles[i]); 
			fprintf(stderr,"Can't open input file %s\n",offfiles[i]); 
			exit (0); }
fprintf(stderr,"Parsing offset file %s\n",xmlfilename);
	      xmlparsetree = NULL;
		lineno = 1;
	      xmlparse();
	      fclose (xmlin);
	      myxmlparsetree = xmlparsetree;
		walktree(myxmlparsetree,TREETOP,0);
	}	}


