#define VERSION "1.3"
#define PATCHLEVEL 3

/* Default location and name of harmonics file */
/* This is overridden by the HFILE environment variable or by the -hfile
   switch. */
#define hfile "harmonic.inp"		/* WB 7/00 - use XTide 2.2 files */

/* Default location to show tides for */
/* This is overridden by the LOCATION environment variable or by the
   -location switch. */
#define deflocation "San Francisco"

/* System default config file, read only if neither ~/.[x]tiderc nor
   -config is present.  sysconfig is for tide, xsysconfig is for xtide. */
#define sysconfig "/usr/lib/tiderc"
#define xsysconfig "/usr/lib/xtiderc"

// #define COMPILEDATA
